# CSync
An easy-to-implement configuration syncing library for BepInEx files.<br>
This library will help devs share settings from the host to all other clients.

## Features
- Can serialize a `ConfigEntry` with a drop-in replacement. (`SyncedEntry`)<br>
- No seperate config file system, retains BepInEx support.<br>
- Uses `DataContractSerializer`, a fast and safer alternative to `BinaryFormatter`.<br>
- Provides helpful extension methods.<br>

## Setup & Usage
To setup and use **CSync**, pleaser refer to the [wiki](https://thunderstore.io/c/lethal-company/p/Owen3H/CSync/wiki/).<br>
It is highly recommended mod authors migrate to v2.0.0!

## Important Notes
- This is **NOT** a standalone mod, it is intended for mod developers and does nothing on its own!<br>
- This does **NOT** edit or replace config files directly, everything is done in-memory.<br>
- It will **NOT** sync configs from mods that aren't dependent upon it.<br>
- CSync uses Unity's [Named Messages](https://docs-multiplayer.unity3d.com/netcode/current/advanced-topics/message-system/custom-messages/#named-messages) to avoid **Netcode Patcher** and **NetworkBehaviour**.

## License
This project has the `CC BY-NC-SA 4.0` license.<br>
This means the following terms apply:

**Attribution**<br>
If you remix or adapt this project, appropriate credit must be given.<br>
Cloning the repo with intent to contribute is not subject to this.

**NonCommercial**<br>
You may not use this material for commercial purposes.

**ShareAlike**<br>
When remixing, adapting or building upon this material, you must
distribute the new material under the same license as the original.
